/*
 * fs20d.c
 *
 *  Created on: 08.04.2012
 *      Author: sn
 */

#include "uip.h"
#include "fs20.h"
#include "string.h"
#include "stdio.h"

#define STATE_INIT 0
#define STATE_READ 1
#define STATE_WRITEACK 2

struct fs20d_state
{
	u8_t state;
	char *textptr;
	int textlen;
};

/*---------------------------------------------------------------------------*/
/**
 * \brief      Initialize the web server
 *
 *             This function initializes the web server and should be
 *             called at system boot-up.
 */
void fs20d_init(void)
{
  uip_listen(HTONS(3333));
}
/*---------------------------------------------------------------------------*/

static
PT_THREAD(handle_output(struct httpd_state *s))
{
  //char *ptr;

  PT_BEGIN(&s->outputpt);

  PSOCK_SEND_STR(&s->sout, "OK\n");

  s->state = STATE_READ;

  PT_END(&s->outputpt);
}
/*---------------------------------------------------------------------------*/
static
PT_THREAD(handle_input(struct httpd_state *s))
{
	PSOCK_BEGIN(&s->sin);

	PSOCK_READTO(&s->sin, '\n');

	if (s->state == STATE_INIT)
	{
		if(strncmp(s->inputbuf, "Jojos-iPhone", 12) != 0)
		{
			PSOCK_CLOSE_EXIT(&s->sin);
		}

		s->state = STATE_WRITEACK;
	}

	if (s->state == STATE_READ)
	{
		if(strncmp(s->inputbuf, "FS20", 4) == 0)
		{
			uint32_t val = 0;
			sscanf(s->inputbuf+4, "%x", &val);

			fs20WebCmd = val;
			FS20Send(0x33330000 | val);
		}

		s->state = STATE_WRITEACK;
	}

	PSOCK_END(&s->sin);
}

static
void handle_connection(struct httpd_state *s)
{
	handle_input(s);

	if(s->state == STATE_WRITEACK)
	{
	  handle_output(s);
	}
}

void fs20d_appcall(void)
{
	struct httpd_state *s = (struct httpd_state *)&(uip_conn->appstate);

	if(uip_closed() || uip_aborted() || uip_timedout())
	{
	}
	else if(uip_connected())
	{
		PSOCK_INIT(&s->sin, s->inputbuf, sizeof(s->inputbuf) - 1);
		PSOCK_INIT(&s->sout, s->inputbuf, sizeof(s->inputbuf) - 1);
		PT_INIT(&s->outputpt);
		s->state = STATE_INIT;
		/*    timer_set(&s->timer, CLOCK_SECOND * 100);*/
		s->timer = 0;
		handle_connection(s);
	} else if(s != NULL)
	{
		if(uip_poll())
		{
			++s->timer;
			if(s->timer >= 20)
			{
				uip_abort();
			}
		}
		else
		{
			s->timer = 0;
		}
		handle_connection(s);
	}
	else
	{
		uip_abort();
	}
}
